/*********************************************************************
 *
 * COMMON.C
 *
 **********************************************************************/


/*--------------------------------------------------------------------
 * ֌W
 *--------------------------------------------------------------------*/


/*
 * mۂ
 */
void *AllocMemory(DWORD dwSize)
{
    return(VirtualAlloc(0, dwSize, MEM_COMMIT, PAGE_EXECUTE_READWRITE));
}


/*
 * J
 */
void FreeMemory(void *lpMem)
{
    VirtualFree(lpMem, 0, MEM_RELEASE);
}


/*--------------------------------------------------------------------
 * t@C֌W
 *--------------------------------------------------------------------*/


/*
 * ǂݍ݃[hŃt@CJ
 */
HANDLE OpenFileR(char *lpFileName)
{
    return(CreateFile(lpFileName, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0));
}


/*
 * ݃[hŃt@CJ
 */
HANDLE OpenFileW(char *lpFileName)
{
    return(CreateFile(lpFileName, GENERIC_WRITE, FILE_SHARE_READ, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0));
}


/*
 * ǋL[hŃt@CJ
 */
HANDLE OpenFileA(char *lpFileName)
{
    return(CreateFile(lpFileName, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0));
}


/*
 * sǂݍ
 */
DWORD ReadFileLine(HANDLE hFile, char *lpLine, DWORD dwSize)
{
    DWORD dwResult;
    char  *lpStr;

    if (dwSize < 1) {
        return(0);
    }
    ReadFile(hFile, lpLine, dwSize - 1, &dwResult, 0);
    if (dwResult == 0) {
        return(0);
    }
    lpLine[dwResult] = 0;
    lpStr            = lpLine;
    while (*lpStr) {
        if (*(WORD *) lpStr == 0x0A0D) {
            *lpStr = 0;
            lpStr += 2;
            break;
        }
        lpStr++;
    }
    dwSize = lpStr - lpLine;
    if (dwSize != dwResult) {
        SetFilePointer(hFile, dwSize - dwResult, 0, FILE_CURRENT);
    }
    return(dwSize);
}


/*
 * eLXg
 */
DWORD WriteFileText(HANDLE hFile, char *lpText)
{
    DWORD dwSize;
    char  *lpStr;

    lpStr = lpText;
    while (*lpStr) {
        lpStr++;
    }
    dwSize = lpStr - lpText;
    WriteFile(hFile, lpText, dwSize, &dwSize, 0);
    return(dwSize);
}


/*--------------------------------------------------------------------
 * ֌W
 *--------------------------------------------------------------------*/


/*
 * ̒擾
 */
long StrLen(char *lpStr)
{
    char *lpHead;

    lpHead = lpStr;
    while (*lpHead) {
        lpHead++;
    }
    return(lpHead - lpStr);
}


/*
 * Rs[
 */
char *StrCpy(char *lpDst, char *lpSrc)
{
    char chr;

    do {
        chr      = *lpSrc++;
        *lpDst++ = chr;
    } while (chr);
    return(lpDst - 1);
}


/*
 * r
 */
long StrCmp(char *lpStr1, char *lpStr2)
{
    BYTE chr1;
    BYTE chr2;

    chr1 = *lpStr1;
    chr2 = *lpStr2;
    while (chr1 == chr2) {
        if (chr1 == 0) {
            return(0);
        }
        chr1 = *++lpStr1;
        chr2 = *++lpStr2;
    }
    if (chr1 > chr2) {
        return(1);
    }
    return(-1);
}


/*
 * r
 */
long StrCmpN(char *lpStr1, char *lpStr2, DWORD dwLength)
{
    BYTE chr1;
    BYTE chr2;

    while (dwLength) {
        chr1 = *lpStr1;
        chr2 = *lpStr2;
        if (chr1 != chr2) {
            if (chr1 > chr2) {
                return(1);
            }
            return(-1);
        }
        lpStr1++;
        lpStr2++;
        dwLength--;
    }
    return(0);
}


/*
 * 񂩂̃ZRs[
 */
void StrCell(char *lpStr, long nIndex, char *lpCell)
{
    char *lpFoot;
    char *lpHead;
    char chr;

    lpHead = lpFoot = lpStr;
    chr    = *lpFoot;
    while (chr) {
        if (chr == '\t') {
            if (nIndex == 0) {
                break;
            }
            lpHead = lpFoot + 1;
            nIndex--;
        }
        chr = *++lpFoot;
    }
    if (nIndex == 0) {
        while (lpHead != lpFoot) {
            *lpCell++ = *lpHead++;
        }
    }
    *lpCell = 0;
}


/*
 * l
 */
long DecToInt(char *lpDec)
{
    char chr;
    long nInt;

    nInt = 0;
    for (;;) {
        chr = *lpDec++;
        if ((chr >= '0') && (chr <= '9')) {
            chr = chr - '0';
        }
        else {
            return(nInt);
        }
        nInt = nInt * 10 + chr;
    }
}


/*--------------------------------------------------------------------
 * ̑
 *--------------------------------------------------------------------*/


/*
 * VXe^CɕbZ
 */
void AddSystemTime(SYSTEMTIME *st, long nSecond)
{
    DWORD    dwHigh;
    DWORD    dwLow;
    DWORD    dwOld;
    FILETIME ft;

    SystemTimeToFileTime(st, &ft);
    dwHigh = ft.dwHighDateTime;
    dwLow  = ft.dwLowDateTime;
    while (nSecond > 0) {
        dwOld  = dwLow;
        dwLow += 10000000;
        if (dwLow < dwOld) {
            dwHigh++;
        }
        nSecond--;
    }
    while (nSecond < 0) {
        dwOld  = dwLow;
        dwLow -= 10000000;
        if (dwLow > dwOld) {
            dwHigh--;
        }
        nSecond++;
    }
    ft.dwHighDateTime = dwHigh;
    ft.dwLowDateTime  = dwLow;
    FileTimeToSystemTime(&ft, st);
}


/*
 * W[̃fBNg̎擾
 */
void GetModuleDirName(HMODULE hModule, char *lpDirName, DWORD dwSize)
{
    char *lpFoot;
    char *lpHead;
    char chr;

    GetModuleFileName(hModule, lpDirName, dwSize);
    lpHead = lpFoot = lpDirName;
    chr    = *lpFoot;
    while (chr) {
        if (chr == '\\') {
            lpHead = lpFoot + 1;
        }
        lpFoot = CharNext(lpFoot);
        chr    = *lpFoot;
    }
    *lpHead = 0;
}


/*
 * INIt@C̎擾
 */
void GetInitFileName(char *lpFileName, DWORD dwSize)
{
    char *lpFoot;
    char *lpHead;
    char chr;

    GetModuleFileName(0, lpFileName, dwSize);
    lpHead = lpFoot = lpFileName;
    chr    = *lpFoot;
    while (chr) {
        if (chr == '.') {
            lpHead = lpFoot + 1;
        }
        lpFoot = CharNext(lpFoot);
        chr    = *lpFoot;
    }
    lpHead[0] = 'i';
    lpHead[1] = 'n';
    lpHead[2] = 'i';
    lpHead[3] = 0;
}


/*
 * vZXs
 */
void ExecuteProcess(char *lpCmdLine, BOOL bShow, BOOL bWait)
{
    MSG                 msg;
    PROCESS_INFORMATION pi;
    STARTUPINFO         si;

    ZeroMemory(&si, sizeof(STARTUPINFO));
    si.cb      = sizeof(STARTUPINFO);
    si.dwFlags = STARTF_USESHOWWINDOW;
    if (bShow) {
        si.wShowWindow = SW_SHOW;
    }
    else {
        si.wShowWindow = SW_HIDE;
    }
    CreateProcess(0, lpCmdLine, 0, 0, FALSE, 0, 0, 0, &si, &pi);
    if (bWait) {
        while (WaitForSingleObject(pi.hProcess, 0) == WAIT_TIMEOUT) {
            while (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)) {
                GetMessage(&msg, NULL, 0, 0);
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
        }
    }
    CloseHandle(pi.hProcess);
}
