/*********************************************************************
 *
 * LOG.C
 *
 **********************************************************************/
#define LOG
#ifdef LOG


/*--------------------------------------------------------------------
 * O[oϐ̒`
 *--------------------------------------------------------------------*/


/*
 *
 */
HANDLE gLogFile;
char   gLogText[1024];


/*--------------------------------------------------------------------
 * ֐̒`
 *--------------------------------------------------------------------*/


/*
 * 
 */
void InitLog(void)
{
    SYSTEMTIME st;
    char       szFileName[1024];

    GetLocalTime(&st);
    wsprintf(szFileName, "LOG_%02d%02d%02d.TXT", st.wYear % 100, st.wMonth, st.wDay);
    gLogFile = OpenFileW(szFileName);
}


/*
 * J
 */
void FreeLog(void)
{
    CloseHandle(gLogFile);
}


/*
 * eLXg̏o
 */
#define PrintLog0(fmt)                                { WriteFileText(gLogFile, fmt); }
#define PrintLog1(fmt, p1)                            { wsprintf(gLogText, fmt, p1); WriteFileText(gLogFile, gLogText); }
#define PrintLog2(fmt, p1, p2)                        { wsprintf(gLogText, fmt, p1, p2); WriteFileText(gLogFile, gLogText); }
#define PrintLog3(fmt, p1, p2, p3)                    { wsprintf(gLogText, fmt, p1, p2, p3); WriteFileText(gLogFile, gLogText); }
#define PrintLog4(fmt, p1, p2, p3, p4)                { wsprintf(gLogText, fmt, p1, p2, p3, p4); WriteFileText(gLogFile, gLogText); }
#define PrintLog5(fmt, p1, p2, p3, p4, p5)            { wsprintf(gLogText, fmt, p1, p2, p3, p4, p5); WriteFileText(gLogFile, gLogText); }
#define PrintLog6(fmt, p1, p2, p3, p4, p5, p6)        { wsprintf(gLogText, fmt, p1, p2, p3, p4, p5, p6); WriteFileText(gLogFile, gLogText); }
#define PrintLog7(fmt, p1, p2, p3, p4, p5, p6, p7)    { wsprintf(gLogText, fmt, p1, p2, p3, p4, p5, p6, p7); WriteFileText(gLogFile, gLogText); }


/*
 * oCif[^̏o
 */
void BinaryLog(BYTE *lpData, DWORD dwSize)
{
    DWORD temp;
    char  *lpText;
    long  nIndex;

    lpText    = gLogText;
    lpText[0] = ' ';
    lpText[1] = ' ';
    lpText[2] = ' ';
    lpText[3] = 0;
    lpText   += 3;
    nIndex    = 0;
    while (dwSize) {
        wsprintf(lpText, " %02X", *lpData++);
        lpText += 3;
        dwSize--;
        nIndex++;
        if ((nIndex >= 16) && dwSize) {
            nIndex    = 0;
            lpText[0] = '\r';
            lpText[1] = '\n';
            lpText[2] = 0;
            lpText   += 2;
            WriteFile(gLogFile, gLogText, lpText - gLogText, &temp, 0);
            lpText    = gLogText;
            lpText[0] = ' ';
            lpText[1] = ' ';
            lpText[2] = ' ';
            lpText[3] = 0;
            lpText   += 3;
        }
    }
    lpText[0] = '\r';
    lpText[1] = '\n';
    lpText[2] = 0;
    lpText   += 2;
    WriteFile(gLogFile, gLogText, lpText - gLogText, &temp, 0);
}


/*--------------------------------------------------------------------
 *
 *--------------------------------------------------------------------*/
#else
#define InitLog()                                     { }
#define FreeLog()                                     { }
#define BinaryLog(data, size)                         { }
#define PrintLog0(fmt)                                { }
#define PrintLog1(fmt, p1)                            { }
#define PrintLog2(fmt, p1, p2)                        { }
#define PrintLog3(fmt, p1, p2, p3)                    { }
#define PrintLog4(fmt, p1, p2, p3, p4)                { }
#define PrintLog5(fmt, p1, p2, p3, p4, p5)            { }
#define PrintLog6(fmt, p1, p2, p3, p4, p5, p6)        { }
#define PrintLog7(fmt, p1, p2, p3, p4, p5, p6, p7)    { }
#endif
